''This is part of an object pair... the other half is FocusLens--cameraProp.spin
''Video from the UnserInterface prop is fed to a video project and projected onto a wall or
''screen.  The cameraProp then displays image data from the right and left sensors.
''see FocusLens--cameraProp.spin for further destails.

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 1
  reps = 4
  bpin =20  'video basepine
  triggerout = 12

  tsl_clk  =8
  tsl_si   = 9
  mcp_clk  = 15
  mcp_data = 13
  mcp_cs   = 12
  triggerIn  = 13          'trigger in
  channel  = 0    'mcp base channel
  remote  = 4

VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[16]
  long range,center,voffset,maxval,minval,cmd,t1,tip,maxdifflpix,noisefloor,temp
  long maxdiffrpix,aL,aR,aP,gotangle,pD,distance,lastdistance
  word dataL[128],dataR[128]     
OBJ
 ' io    :"FullDuplexSerial"
  tv    : "tv"
  gr    : "graphics2"
 
PUB start | i,line
  dira[triggerout]:=1
  InitParams
  gr.start
 
  gr.setup(16, 12, 128, 96, bitmap_base)
  gr.clear
 ' gr.colorwidth(3,0)
  gr.colorwidth(2,0 )  
  line:=-0
  plotline(0)
  gr.copy(display_base)
  repeat
       Plotline(0)
       gr.copy(display_base)
       outa[triggerout]:=1
       repeat until ina[triggerin]==1
       
       gr.clear
       gr.copy(display_base)
       outa[triggerout]:=0
       repeat until ina[triggerin] == 0

pub plot  |i, j,jj,k, kk,px,py,dechr,gotleft,gotright

    gr.clear
    gr.colorwidth(3,0)
    gr.colorwidth(2,0 )
   ' gr.text(64,80,@pchip)

    range:=10
    gr.colorwidth(2,0)

    
    gr.color(2)

    gr.copy(display_base)
Pub PlotLine(whichline)

      gr.plot (whichline,-100)
      gr.line (whichline,100)
      gr.copy(display_base)

Pub plotInt (value,x,y) | i,kk,dechr
    i:=0                           
    repeat until value == 0
       kk:=value//10
       value:=value/10
       dechr:=num +kk
       gr.text(x-(i*6),y,@dechr)
       i:=i+1 


    
Pub InitParams   | i,dx,dy
  Tip:=50000         'TSL integration period parameter....integration clocks =  3136 + (448*tip)
  voffset:=94    'adjusts plot x,y location.  Can be used in future to implement full windowing logic
  noisefloor:=50
  pD:=74
  longmove(@tv_status, @tvparams, paramcount)
  
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  repeat i from 0 to 16
    colors[i] := $00001010 * (i+20) & $F + $2B060C02
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
                             
 

 
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long     (bpin & $38) << 1 | (bpin & 4 == 4) & %0101 
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog
IntegPeriod             byte    "Integ(usec)",0
PixelVal                byte    "Pix/ ",0
'pchip                   byte    "Propeller",0           'text
num                     byte    "0",0,"1",0,"2",0,"3",0,"4",0,"5",0,"6",0,"7",0,"8",0,"9",0